apiVersion: v1
kind: Service
metadata:
  name: java-code-base-service
  labels:
    app: java-code-base-service
spec:
  type: NodePort
  ports:
  - port: 8080
    targetPort: 8080
    protocol: TCP
    name: rest-api
  selector:
    app: java-code-base-deploy

---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: java-code-base-deploy
  labels:
    app: java-code-base-deploy
spec:
  replicas: 2
  selector:
    matchLabels:
      app: java-code-base-deploy
  template:
    metadata:
      labels:
        app: java-code-base-deploy
        deployKey: "{DEPLOY_KEY}"
    spec:
      # for pull docker image from private registry
      imagePullSecrets:
      - name: regcystudio
      containers:
      - name: java-code-base-deploy
        image: gitlab.cystudio.tw:9500/cystudio/back-end/javacodebase:{TAG_VERSION}
        env:
        - name: SETUP_ENV
          value: "{SETUP_ENV}"
        imagePullPolicy: Always
        ports:
        - containerPort: 8080
---
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: java-code-base-ingress
  labels:
    app: java-code-base-ingress
  annotations:
    kubernetes.io/ingress.class: "nginx"
    nginx.ingress.kubernetes.io/enable-cors: "true"
    nginx.ingress.kubernetes.io/cors-allow-origin: "*"
    nginx.ingress.kubernetes.io/cors-allow-methods: "PUT, GET, POST, OPTIONS, DELETE"
    nginx.ingress.kubernetes.io/cors-allow-headers: "DNT,X-CustomHeader,X-LANG,Keep-Alive,User-Agent,X-Requested-With,If-Modified-Since,Cache-Control,Content-Type,X-Api-Key,X-Device-Id"

    
spec:
  rules:
  - host: {HOST_NAME}
    http:
      paths: 
      - path: /
        pathType: ImplementationSpecific
        backend:
          service:
            name: java-code-base-service
            port:
              number: 8080